/**
*   @copyright       © 2025 Microchip Technology Inc.
    Microchip Technology Inc. and its subsidiaries. You may use this
    software and any derivatives exclusively with Microchip products.

    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY IMPLIED
    WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS FOR A
    PARTICULAR PURPOSE, OR ITS INTERACTION WITH MICROCHIP PRODUCTS, COMBINATION
    WITH ANY OTHER PRODUCTS, OR USE IN ANY APPLICATION.

    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE,
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP HAS
    BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO THE
    FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL CLAIMS IN
    ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT OF FEES, IF ANY,
    THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS SOFTWARE.

    MICROCHIP PROVIDES THIS SOFTWARE CONDITIONALLY UPON YOUR ACCEPTANCE OF THESE
    TERMS. 
*
*************************************************************************/

#include "support/system/system.h"
#include <xc.h>
#include <stdint.h>
#include <string.h>
#include "drv_led.h"
#include "test.h"

void MainApplicationTask();

/*
    Main application
*/
int main(void)
{   
    SYSTEM_Initialize();
    Drv_LED_Init();
    
    if(RCONbits.WDTO == 1)
    {
        RCONbits.WDTO = 0;
        // ERROR IS DETECTED
        Drv_LED_Control(LED_2, LED_ON);
        while(1)
        {
            //Wait indefinitely
        }
    }
    
    WDTCONbits.ON = 1U;
    
    #if DEMO_CPU_AVAILABLE
    if(DEMO_CPU_RegTestTask() == DEMO_TEST_FAIL)
    {
        // ERROR IS DETECTED
        Drv_LED_Control(LED_1, LED_ON); 
        while(1)
         {
             //WDT shall timeout
         }
    }
    // Clear watchdog.
    ClrWdt();
    #endif

    #if DEMO_INTERRUPT_AVAILABLE
    if(DEMO_INTERRUPT_TestTask() == DEMO_TEST_FAIL)
    {
        // ERROR IS DETECTED
        Drv_LED_Control(LED_1, LED_ON); 
        while(1)
         {
             //WDT shall timeout
         }
    }
    // Clear watchdog.
    ClrWdt();
    #endif
    
    #if DEMO_SRAM_AVAILABLE
    if(DEMO_SRAM_TestTask() == DEMO_TEST_FAIL)
    {
        // ERROR IS DETECTED
        Drv_LED_Control(LED_1, LED_ON); 
        while(1)
         {
             //WDT shall timeout
         }
    }
    // Clear watchdog.
    ClrWdt();
    #endif
    
    #if DEMO_CLOCK_AVAILABLE
    if(DEMO_CLOCK_TestTask() == DEMO_TEST_FAIL)
    {
        // ERROR IS DETECTED
        Drv_LED_Control(LED_1, LED_ON); 
        while(1)
         {
             //WDT shall timeout
         }
    }
    // Clear watchdog.
    ClrWdt();
    #endif

    #if DEMO_ADC_AVAILABLE
    if(DEMO_ADC_TestTask() == DEMO_TEST_FAIL)
    {
        // ERROR IS DETECTED
        Drv_LED_Control(LED_1, LED_ON); 
        while(1)
         {
             //WDT shall timeout
         }
    }
    // Clear watchdog.
    ClrWdt();
    #endif

    #if DEMO_TIMER_AVAILABLE
    if(DEMO_TIMER_TestTask() == DEMO_TEST_FAIL)
    {
        // ERROR IS DETECTED
        Drv_LED_Control(LED_1, LED_ON); 
        while(1)
         {
             //WDT shall timeout
         }
    }
    // Clear watchdog.
    ClrWdt();
    #endif

    #if DEMO_CPU_AVAILABLE
    if(DEMO_CPU_TestTask() == DEMO_TEST_FAIL)
    {
        // ERROR IS DETECTED
        Drv_LED_Control(LED_1, LED_ON); 
        while(1)
         {
             //WDT shall timeout
         }
    }
    // Clear watchdog.
    ClrWdt();
    #endif
    
    #if DEMO_FLASH_AVAILABLE
    if(DEMO_FLASH_TestTask() == DEMO_TEST_FAIL)
    {
        // ERROR IS DETECTED
        Drv_LED_Control(LED_1, LED_ON); 
        while(1)
         {
             //WDT shall timeout
         }
    }
    // Clear watchdog.
    ClrWdt();
    #endif

    #if DEMO_CRC_AVAILABLE
    if(DEMO_CRC_TestTask() == DEMO_TEST_FAIL)
    {
        // ERROR IS DETECTED
        Drv_LED_Control(LED_1, LED_ON); 
        while(1)
         {
             //WDT shall timeout
         }
    }
    // Clear watchdog.
    ClrWdt();
    #endif

    #if DEMO_PC_AVAILABLE
    if(DEMO_PC_TestTask() == DEMO_TEST_FAIL)
    {
        // ERROR IS DETECTED
        Drv_LED_Control(LED_1, LED_ON); 
        while(1)
         {
             //WDT shall timeout
         }
    }
    // Clear watchdog.
    ClrWdt();
    #endif

    #if DEMO_GPIO_AVAILABLE
    if(DEMO_GPIO_TestTask() == DEMO_TEST_FAIL)
    {
        // ERROR IS DETECTED
        Drv_LED_Control(LED_1, LED_ON); 
        while(1)
         {
             //WDT shall timeout
         }
    }
    // Clear watchdog.
    ClrWdt();
    #endif
    
    while (1)
    {
        // Run main application.
        MainApplicationTask();
        
        // Clear watchdog.
        ClrWdt();
    }
    return 1;   
}

void MainApplicationTask()
{
    // APPLICATION CODE SHOULD BE HERE.
    
    /*
    For periodic/on demand diagnostics, the user shall call the corresponding
    APIs
    */
    
    //All tests passed
    Drv_LED_Control(LED_0, LED_ON);
}